function [Cosine, Sine] = gaborfilter(scale, orientation, imagesize)
% [Cosine, Sine] = gaborfilter(scale, orientation, imagesize)

filtersize = scale * 20  + 1;     % size of the base
halfsize = scale * 10  + 1;        % half-size
theta = (pi * orientation)/180;    % orientation in real number

Cosine = zeros(filtersize); 
Sine = zeros(filtersize);       
for i = 1:filtersize
  for j = 1:filtersize
    x = ((i-halfsize) * cos(theta) + (j-halfsize) * sin(theta))/scale;
    y = ((halfsize-i) * sin(theta) + (j-halfsize) * cos(theta))/scale;
    gauss = exp(-(4*x*x+y*y)/100)/50/pi/scale/scale; 
    Cosine(i, j) = gauss*cos(x);
    Sine(i, j) = gauss*sin(x);                   
 end
end






