function [B, C] = dog(sigma)

% [B, C] = dog(sigma)

% Center-sorround DOG base

% sigma: scale

% B: the base matrix

% C: the symbolic representation



size = sigma*6 + 1;     % the size of the base matrix 

c = sigma*3 + 1;        % the half size



B = zeros(size);        % B: the base matrix 

r = .9; s = 1;          % the sizes of center and sorround 

for i = 1:size

  for j = 1:size

    x = (i-c)/sigma;

    y = (j-c)/sigma;    % scale x and y

    B(i, j) = G(x, r)*G(y, r) - G(x, s)*G(y, s);

                        % difference between center and sorround

 end

end



tmp = B(:); 

B = B/sqrt(sum(tmp.*tmp));  % normalize to have norm 1



if (rem(size, 2)==0)        % matrix size should be odd

   B1 = zeros(size+1); 

   B1(1:size, 1:size) = B;

   B = B1; 

end





C = B-B;            % symbolic representation

for i = 1:size

  for j = 1:size

    x = (i-c);

    y = (j-c);

    r = sqrt(x*x+y*y); 

    if ((r<=sigma+1) & (r>=sigma-1)) 

         C(i, j) = 1/2;       % a circle 

    end

 end

end







