function FI = mp(I, F, C, threshold)

% FI = mp(I, F, C, threshold)

%----------------------------------------------------------

% Mallat's matching pursuit algorithm

% Sequentially add one base at a time that results in the 

% largest decrease of squared error

%----------------------------------------------------------

% I: the input image 

% F: the filter bank

% C: the correlation/inhibition matrix

% threshold: the threshold for stopping the pursuit 

% FI: the synthesis coefficients



I = double(I); 

I = I - mean(I(:));   

I = I/sqrt(var(I(:)));  % normalize I to have mean 0 variance 1 



N = size(F, 2);    % the number of filters

M = size(I);       % the size of the image 

for (i = 1:N)

   FI{i} = zeros(M);   % the synthesis coefficients for filter i

   fI{i} = filter2(F{i}.ker, I, 'same'); 

  % fI is the analysis coefficient of filter i for remainder image

end

   

Cmp(I, F, fI, FI, C, threshold);

% Cmp is the mex C file for heavy duty computation    

   

      