function v = view(I, FI, F, FS)

% v = view(I, FI, F, FS)

% view results of match pursuit

% I: original image

% FI: synthesis coefficients 

% F: filters 

% FS: symbolic filters 

% v: variance of error 



I = double(I); 

I = I - mean(I(:));   

I = I/sqrt(var(I(:)));  % normalize I to have mean 0 variance 1 

J = synthesize(FI, F);  % synthesized image */



mx = max(max(I(:)), max(J(:))); 

mn = min(min(I(:)), min(J(:))); 

Im = (I-mn)/(mx-mn); 

Jm = (J-mn)/(mx-mn);    % normalize I and J to [0, 1] for viewing



J1 = synthesize(FI, FS);   % symbolic synthesis 

subplot(1, 2, 1); imshow(J1, []); 

 

D = I-J; 

Dm = (D-mn)/(mx-mn);       % remainder image 

subplot(1, 2, 2); imshow(Dm); 



v = var(I(:)-J(:));        % variance of error 



figure

subplot(1, 2, 1); imshow(Im); 

subplot(1, 2, 2); imshow(Jm);  % show original and synthesized 





